/*
** IDXINFO.C
** Written by Chad Wagner
** eg435@cleveland.freenet.edu
** cmwagner@gate.net
**
** Released to the public domain.
**
** IDXINFO.C was based on SIMCVT.C, mostly the routines to gather the data.
*/

#include <stdio.h>
#include <string.h>

/*
** This define displays the files, directories, and disk space statistics,
** it is used a few times, so I define'd it, and I didn't see a need to
** create a function for it.
*/
#define putstat(a,b,c) printf("total number of files = %lu\ntotal numb" \
                       "er of directories = %lu\ntotal disk space used" \
		       " = %lu\n\n",a,b,c);

/*
** I don't know if strcasecmp() is available on all variations of unix, but
** I did find it on AIX when I compiled this with GCC, also I am assuming DOS
** or UNIX here, so you may need to tweak this for your needs.
*/
#ifdef __MSDOS__
#define STRICMP(a,b) stricmp(a,b)
#else
#define STRICMP(a,b) strcasecmp(a,b)
#endif

void main(int,char **);

void main(int argc,char **argv)
{
FILE *f;
unsigned char buf[256]={0},lfs[10]={0},ldir[60]={0},fs[10]={0},dir[60]={0},
				  name[15]={0},a,dFlag = 0,*self;
unsigned long tFiles,gFiles,tDirectory,gDirectory,tSize,gSize,length,
              dFiles,dSize;

	  if (argc < 2) {
			 #ifdef __MSDOS__
			 self = strrchr(argv[0],'\\');
			 self++;
			 #else
			 self = argv[0];
			 #endif

			 printf("%s [-d] <filename[.idx]>\n\n",self);
          printf("-d = show directory totals\n");
          return;
     }

     gFiles = 0;
     gDirectory = 0;
     gSize = 0;

	  for (a=1; a<argc; a++) {
			 if (STRICMP(argv[a],"-d") == 0) {
					dFlag = 1;
					continue;
			 }
			 strcpy(buf,argv[a]);
          if (strrchr(buf,'.') == NULL)
               strcat(buf,".idx");

          if ((f = fopen(buf,"r")) == NULL) {
               printf("idxinfo: can't open %s\n",buf);
               return;
          }

          tFiles = 0;
          tDirectory = 0;
          tSize = 0;

          printf("%s:\n",buf);

          while(fgets(buf,sizeof(buf),f) != NULL) {
               sscanf(buf,
               "\"%[^\"]\",\"%[^\"]\",\"%[^\"]\",%*d,%lu,%*d,%*ld,\""
               "%*[^\"]\"",fs,dir,name,&length);


               if ((strcmp(fs,lfs) != 0) || (strcmp(dir,ldir) != 0)) {
		  if ((*ldir != (char)NULL) && (dFlag)) {
			 if (*lfs != (char)NULL) {
				printf("%s",lfs);
			 }
			 printf("%s: %lu files %lu bytes\n",ldir,dFiles,
			 dSize);
		  }

                  dFiles = 0;
                  dSize = 0;
                  strcpy(lfs,fs);
                  strcpy(ldir,dir);
                  tDirectory++;
               }

               tSize += length;
               dSize += length;
               tFiles++;
               dFiles++;
          }

          fclose(f);
          putstat(tFiles,tDirectory,tSize);
          gFiles += tFiles;
          gDirectory += tDirectory;
          gSize += tSize;
     }
     printf("total:\n");
     putstat(gFiles,gDirectory,gSize);
}
