#!/usr/bin/awk -f

# simcvt3.awk is an Awk script which converts a SimTel MSDOS simibm.idx
# index file to a simibm.lst list file.  It is freely distributable.

# Usage:  awk -f simcvt3.awk simibm.idx > simibm.lst
# Author: Daniel S. Lewart (d-lewart@uiuc.edu) 1 Jan 1995

BEGIN {
	FS = "\""
print "These files are available by anonymous FTP from the SimTel primary"
print "mirror site OAK.Oakland.Edu (141.210.10.117) and its mirrors.  See"
print "/SimTel/msdos/filedocs/download.inf for a list of all mirror sites."
	print ""
	print "NOTE: Type B is Binary; Type A is ASCII"
	print ""
}

{
	dir2 = $2$4
	if ( dir1 != dir2 ) {
		if ( dir1 != "" ) print ""
		print "Directory", dir2
		print " Filename   Type Length   Date    Description"
		print "=============================================="
		dir1 = dir2
	}
	Name = $6
	split($7,a,",")
	Type = "?"
	if (a[4] == 7) Type = "A"
	if (a[4] == 8) Type = "B"
	Size = a[3]
	Date = a[5]
	Description = $8
	printf("%-12s  %s %7d  %6d  %s\n",Name,Type,Size,Date,Description)
}
